<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_ZoneInfo ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_ZoneInfo extends AbstractStructArrayBase
{
    /**
     * The ZoneInfo
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_ZoneInfo[]
     */
    public $ZoneInfo;
    /**
     * Constructor method for ArrayOfJP_ZoneInfo
     * @uses ArrayOfJP_ZoneInfo::setZoneInfo()
     * @param \StructType\JP_ZoneInfo[] $zoneInfo
     */
    public function __construct(array $zoneInfo = array())
    {
        $this
            ->setZoneInfo($zoneInfo);
    }
    /**
     * Get ZoneInfo value
     * @return \StructType\JP_ZoneInfo[]|null
     */
    public function getZoneInfo()
    {
        return $this->ZoneInfo;
    }
    /**
     * Set ZoneInfo value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_ZoneInfo[] $zoneInfo
     * @return \ArrayType\ArrayOfJP_ZoneInfo
     */
    public function setZoneInfo(array $zoneInfo = array())
    {
        foreach ($zoneInfo as $arrayOfJP_ZoneInfoZoneInfoItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_ZoneInfoZoneInfoItem instanceof \StructType\JP_ZoneInfo) {
                throw new \InvalidArgumentException(sprintf('The ZoneInfo property can only contain items of \StructType\JP_ZoneInfo, "%s" given', is_object($arrayOfJP_ZoneInfoZoneInfoItem) ? get_class($arrayOfJP_ZoneInfoZoneInfoItem) : gettype($arrayOfJP_ZoneInfoZoneInfoItem)), __LINE__);
            }
        }
        $this->ZoneInfo = $zoneInfo;
        return $this;
    }
    /**
     * Add item to ZoneInfo value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_ZoneInfo $item
     * @return \ArrayType\ArrayOfJP_ZoneInfo
     */
    public function addToZoneInfo(\StructType\JP_ZoneInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_ZoneInfo) {
            throw new \InvalidArgumentException(sprintf('The ZoneInfo property can only contain items of \StructType\JP_ZoneInfo, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ZoneInfo[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_ZoneInfo|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_ZoneInfo|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_ZoneInfo|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_ZoneInfo|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_ZoneInfo|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ZoneInfo
     */
    public function getAttributeName()
    {
        return 'ZoneInfo';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_ZoneInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
